<template>
  <div>
    <b-container>
      <b-row>
        <b-col>
          <b-form-input v-model="title" placeholder="Title"></b-form-input>
        </b-col>
      </b-row>
      <b-row>
        <b-col>
          <b-form-textarea
            id="textarea"
            v-model="content"
            placeholder="Enter something..."
            rows="3"
            max-rows="6"
          ></b-form-textarea>
        </b-col>
      </b-row>
      <b-row>
        <b-col>
          <label for="start-date">วันเริ่มต้น</label
          ><b-form-datepicker
            id="start-date"
            v-model="startDate"
            class="mb-2"
            locale="th"
          ></b-form-datepicker>
        </b-col>
        <b-col>
          <label for="start-time">เวลาเริ่มต้น</label>
          <b-form-timepicker
            id="start-time"
            v-model="startTime"
            locale="th"
          ></b-form-timepicker>
        </b-col>
      </b-row>
      <b-row>
        <b-col>
          <label for="end-date">วันสิ้นสุด</label
          ><b-form-datepicker
            id="end-date"
            v-model="endDate"
            class="mb-2"
            locale="th"
          ></b-form-datepicker>
        </b-col>
        <b-col>
          <label for="end-time">เวลาสิ้นสุด</label>
          <b-form-timepicker
            id="emd-time"
            v-model="endTime"
            locale="th"
          ></b-form-timepicker>
        </b-col>
      </b-row>
      <b-row>
        <b-col>
          <b-button @click="addEvent">Add</b-button>
        </b-col>
      </b-row>
      <b-row>
        <b-col>
          <vue-cal :locale="th" active-view="week" :events="events" @ready="ready($event)" @view-change="viewChange($event)"/>
        </b-col>
      </b-row>

    </b-container>
  </div>
</template>
<script>
import VueCal from 'vue-cal'
import 'vue-cal/dist/vuecal.css'
import th from '../locale/th'
import { getEvent } from '../services/event'
export default {
  data () {
    return {
      startDate: '',
      endDate: '',
      startTime: '',
      endTime: '',
      title: '',
      content: '',
      events: [
        {
          start: '2022-03-26 14:00',
          end: '2022-03-26 16:00',
          title: 'ทำงาน',
          content: 'นั่งกัดฟันทำงาน',
          class: 'a'
        }
      ]
    }
  },
  methods: {
    addEvent () {
      const event = {
        start: this.startDate + ' ' + this.startTime,
        end: this.endDate + ' ' + this.endTime,
        title: this.title,
        content: this.content,
        class: 'vdo_time'
      }
      console.log(event)
      this.events.push(event)
    },
    async ready (e) {
      console.log('ready', e)
      const res = await getEvent(e.startDate, e.endDate)
      console.log(res)
      // const newEvent = []
      // for (let i = 0; i < res.data.length; i++) {
      //   const event = res.data[i]
      //   newEvents.push({
      //     start: new Date(event.startDate),
      //     end: new Date(event.endDate),
      //     title: event.title,
      //     content: event.content,
      //     class: event.class
      //   })
      // }
      const newEvents = res.data.map(function (event) {
        return {
          start: new Date(event.startDate),
          end: new Date(event.endDate),
          title: event.title,
          content: event.content,
          class: event.class
        }
      })
      this.events = newEvents
    },
    async viewChange (e) {
      console.log('view-change', e)
      const res = await getEvent(e.startDate, e.endDate)
      console.log(res)
      const newEvents = res.data.map(function (event) {
        return {
          start: new Date(event.startDate),
          end: new Date(event.endDate),
          title: event.title,
          content: event.content,
          class: event.class
        }
      })
      this.events = newEvents
    }
  },
  computed: {
    th () {
      return th
    }
  },
  components: {
    VueCal
  }
}
</script>
<style>
.vuecal__now-line {
  color: #06c;
}
.vuecal__event.a {
  background-color: rgba(253, 156, 66, 0.9);
  border: 1px solid rgb(233, 136, 46);
  color: #fff;
}
.vuecal__event.b {background-color: rgba(0, 156, 66, 0.9);border: 1px solid rgb(0, 136, 46);color: #fff;}
.vuecal__event.c {background-color: rgba(255, 102, 102, 0.9);border: 1px solid rgb(235, 82, 82);color: #fff;}
</style>
